#!/usr/bin/python
from datetime import *
from calendar import *
from uurrooster import *

# Een mooiere tabelweergave dan deze van de denayer cgi is welkom, work in progress...

# werkingsprincipe: eerst de rooster in geheugen construeeren, dan omzetten naar html tabel.

def createtable(daylist, calendar):
	uurrange = range(7,18)
	minrange = (0,30)
	weekdagen = ["Maandag","Dinsdag","Woensdag","Donderdag","Vrijdag","Zaterdag"]

	print "<table border='1'>"
	
	print "<th>"
	print "<td width='5%'>&nbsp;</td>"
	for day in daylist:
		dayhead = weekdagen[day.weekday()] + ' ' + day.isoformat()
		print "<td>%s</td>" % dayhead
	print "</th>"
	
	for uur in uurrange:
		for minute in minrange:
			print "<tr>"
			if minute == 0:
				print "<td style='border-top: 1px black solid; text-align: top;' rowspan='2'>%s</td>" % uur
			print "<td style='border-top: 1px black solid;'>%s</td>" % minute
			timeobj = time(uur,minute, tzinfo = CEST())

			for day in daylist:
				dt = datetime.combine(day, timeobj)
				match = 0
				for event in calendar:
					if event['begin'] == dt:
						match = event
				if match != 0:
					d = match['einde'] - match['begin']
					rowspan = (d.seconds/(60*60.0)) + 1
					print "<td rowspan='%s'>%s</td>" % (rowspan, match["naam"])
				else:
					print "<td></td>"

				print "</td>"

			print "</tr>"
				
	print "</table>"
klas = Uurrooster("2pbei1")
klas.retrieve()
daylist = []

for n in range(3,8):
	daylist.append(date(2005,10,n))
print "<html>"
print "<body>"
createtable(daylist, klas.lessen)
print "</body>"
print "</html>"
